xml地图|网站地图|网站标签 [设为首页] [加入收藏]

PHP异常处理定义与使用方法分析,php封装一个异

来源:http://www.ccidsi.com 作者:呼叫中心培训课程 人气:59 发布时间:2019-08-01
摘要: 本文实例为大家分享了php自定义格外管理类,供大家参照他事他说加以考察,具体内容如下 正文实例叙述了PHP格外管理定义与使用情势。分享给大家供大家参考,具体如下: 本文实例

 本文实例为大家分享了php自定义格外管理类,供大家参照他事他说加以考察,具体内容如下

正文实例叙述了PHP格外管理定义与使用情势。分享给大家供大家参考,具体如下:

本文实例陈说了php相当处理方式。分享给大家供大家参照他事他说加以考察。具体如下:

一、代码

<?php
//php5提供了基本的异常处理类,可直接使用 ,不需要自己再定义
// class Exception
// {
// protected $message = 'Unknown exception'; // 异常信息
// protected $code = 0; // 用户自定义异常代码
// protected $file; // 发生异常的文件名
// protected $line; // 发生异常的代码行号
// function __construct($message = null, $code = 0);
// final function getMessage(); // 返回异常信息
// final function getCode(); // 返回异常代码
// final function getFile(); // 返回发生异常的文件名
// final function getLine(); // 返回发生异常的代码行号
// final function getTrace(); // backtrace() 数组
// final function getTraceAsString(); // 已格成化成字符串的 getTrace() 信息
// /* 可重载的方法 */
// function __toString(); // 可输出的字符串
// }
?>



<?php
//定义一个顶级异常处理
function my_exception($e){
  echo "我是顶级异常处理".$e->getMessage();
}
//修改默认的顶级异常处理函数(器)
set_exception_handler("my_exception");
//我们使用异常机制
try{
  addUser("shunping");
  updateUser("xiaoming1");
}
//catch用来 捕获异常, Exception 是异常类(是php定义好一个类)
catch(Exception $e){
  //返回异常信息
  echo "返回异常信息(失败信息) =".$e->getMessage()."<br/>";
  echo "返回异常代码 =".$e->getCode()."<br/>";
  echo "返回发生异常的文件名 =".$e->getFile()."<br/>";
  echo "返回发生异常的代码行号 =".$e->getLine()."<br/>";
  //echo " =".$e->getTrace()."<br/>"; // backtrace() 数组
  //可以继续抛出,这时将会启动php默认的异常处理器来处理
  //你也可以自己定义一个顶级异常处理器,对其进行处理
  throw $e;
}
function addUser($username){
  if($username=="shunping"){
    //添加ok
    echo "ok1";
  }else{
    //添加error
    //抛出异常.
    throw new Exception("添加失败");
  }
}
function updateUser($username){
  if($username=="xiaoming"){
    //正常修改
    echo "ok2";
  }else{
    //平抛出异常
    throw new Exception("修改失败");
  }
}
?>
<?php 
$path = "D://in.txt"; 
try //检测异常 
{ 
  file_open($path); 
} 
catch(Exception $e) //捕获异常 
{ 
  echo $e->getMessage(); 
} 

function file_open($path) 
{ 
  if(!file_exists($path))
  //如果文件无法找到,抛出异常对象 
  { 
    throw new Exception("文件无法找到", 1); 
  } 
  if(!fopen($path, "r"))
  //如果文件无法打开,抛出异常对象 
  { 
    throw new Exception("文件无法打开", 2); 
  } 
} 
?> 



<?php 
$path = "D://in.txt";
//文件所在路径 
file_open($path);
//调用file_open函数 

function file_open($path) 
{ 
  if(!file_exists($path))
  //如果文件无法找到,抛出异常对象 
  { 
    throw new Exception("文件无法找到", 1); 
  } 
  if(!fopen($path, "r"))
  //如果文件无法打开,抛出异常对象 
  { 
    throw new Exception("文件无法打开", 2); 
  } 
} 
?> 



<?php 
function exception_handler($e)
//用于处理异常的函数 
{ 
 echo "未捕获的异常:".$e->getMessage(); 
} 

set_exception_handler("exception_handler");
//设置异常处理函数 
try //检测异常 
{ 
  $path = "D://in.txt"; 
} 
catch(Exception $e) //捕获异常 
{ 
  echo $e->getMessage(); 
} 
file_open($path); //调用函数打开文件 
function file_open($path) 
{ 
  if(!file_exists($path))
  //如果文件无法找到,抛出异常对象 
  { 
    throw new Exception("文件无法找到", 1); 
  } 
  if(!fopen($path, "r"))
  //如果文件无法打开,抛出异常对象 
  { 
    throw new Exception("文件无法打开", 2); 
  } 
} 
?> 


<?php 
$path = "D://in.txt"; 

try 
{ 
  file_open($path); //尝试打开文件 
} 
catch(Exception $e) 
{ 
  echo "异常信息:".$e->getMessage()."/n";
  //返回用户自定义的异常信息 
  echo "异常代码:".$e->getCode()."/n";
  //返回用户自定义的异常代码 
  echo "文件名:".$e->getFile()."/n";
  //返回发生异常的PHP程序文件名 
  echo "异常代码所在行".$e->getLine()."/n";
  //返回发生异常的代码所在行的行号 
  echo "传递路线:"; 
  print_r($e->getTrace());
  //以数组形式返回跟踪异常每一步传递的路线 
  echo $e->getTraceAsString();
  //返回格式化成字符串的getTrace函数信息 
} 
function file_open($path) 
{ 
  if(!file_exists($path))
  //如果文件不存在,则抛出错误 
  { 
    throw new Exception("文件无法找到", 1); 
  } 

  if(!fopen($path, "r")) 
  { 
    throw new Exception("文件无法打开", 2); 
  } 
} 
?> 



<?php 
class FileExistsException extends Exception{}
//用于处理文件不存在异常的类 
class FileOpenException extends Exception{}
//用于处理文件不可读异常的类 
$path = "D://in.txt"; 
try 
{ 
  file_open($path); 
} 
catch(FileExistsException $e)
//如果产生FileExistsException异常则提示用户确认文件位置 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件位置。"; 
} 
catch(FileOpenException $e)
//如果产生FileOpenException异常则提示用户确认文件的可读性 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件的可读性。"; 
} 
catch(Exception $e) 
{ 
  echo "[未知异常]"; 
  echo "异常信息:".$e->getMessage()."/n";
  //返回用户自定义的异常信息 
  echo "异常代码:".$e->getCode()."/n";
  //返回用户自定义的异常代码 
  echo "文件名:".$e->getFile()."/n";
  //返回发生异常的PHP程序文件名 
  echo "异常代码所在行".$e->getLine()."/n";
  //返回发生异常的代码所在行的行号 
  echo "传递路线:"; 
  print_r($e->getTrace());
  //以数组形式返回跟踪异常每一步传递的路线 
  echo $e->getTraceAsString();
  //返回格式化成字符串的getTrace函数信息 
} 
function file_open($path) 
{ 
  if(!file_exists($path)) 
  { 
    throw new FileExistsException("文件无法找到", 1);
    //抛出FileExistsException异常对象 
  } 

  if(!fopen($path, "r")) 
  { 
    throw new FileOpenException("文件无法打开", 2);
    //抛出FileOpenException异常对象 

  } 
} 
?> 



<?php 
class FileExistsException extends Exception{}
//用于处理文件不存在异常的类 
class FileOpenException extends Exception{}
//用于处理文件不可读异常的类 
$path = "D://in.txt"; 
try 
{ 
  file_open($path); //尝试打开文件 
} 
catch(Exception $e) 
{ 
  echo "[未知异常]"; 
  echo "异常信息:".$e->getMessage()."/n";
  //返回用户自定义的异常信息 
  echo "异常代码:".$e->getCode()."/n";
  //返回用户自定义的异常代码 
  echo "文件名:".$e->getFile()."/n";
  //返回发生异常的PHP程序文件名 
  echo "异常代码所在行".$e->getLine()."/n";
  //返回发生异常的代码所在行的行号 
  echo "传递路线:"; 
  print_r($e->getTrace());
  //以数组形式返回跟踪异常每一步传递的路线 
  echo $e->getTraceAsString();
  //返回格式化成字符串的getTrace函数信息 
} 
catch(FileExistsException $e)
//如果产生FileExistsException异常则提示用户确认文件位置 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件位置。"; 
} 
catch(FileOpenException $e)
//如果产生FileOpenException异常则提示用户确认文件的可读性 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件的可读性。"; 
} 
function file_open($path) 
{ 
  if(!file_exists($path))
  //如果文件不存在,则输出错误 
  { 
    throw new FileExistsException("文件无法找到", 1); 
  } 

  if(!fopen($path, "r")) 
  { 
    throw new FileOpenException("文件无法打开", 2); 
  } 
} 
?> 



<?php 
class FileExistsException extends Exception{}
//用于处理文件不存在异常的类 
class FileOpenException extends Exception{}
//用于处理文件不可读异常的类 
$path = "D://in.txt"; 
try 
{ 
  file_open($path); 
} 
catch(FileExistsException $e)
//如果产生FileExistsException异常则提示用户确认文件位置 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件位置。"; 
} 
catch(FileOpenException $e)
//如果产生FileOpenException异常则提示用户确认文件的可读性 
{ 
  echo "程序在运行过程中发生了异常:".$e->getMessage()."/n"; 
  echo "请确认文件的可读性。"; 
} 
catch(Exception $e) 
{ 
  echo "[未知异常]"; 
  echo "异常信息:".$e->getMessage()."/n";
  //返回用户自定义的异常信息 
  echo "异常代码:".$e->getCode()."/n";
  //返回用户自定义的异常代码 
  echo "文件名:".$e->getFile()."/n";
  //返回发生异常的PHP程序文件名 
  echo "异常代码所在行".$e->getLine()."/n";
  //返回发生异常的代码所在行的行号 
  echo "传递路线:"; 
  print_r($e->getTrace());
  //以数组形式返回跟踪异常每一步传递的路线 
  echo $e->getTraceAsString();
  //返回格式化成字符串的getTrace函数信息 
} 
function file_open($path) 
{ 
  try 
  { 
    if(!file_exists($path)) 
    { 
      throw new FileExistsException("文件无法找到", 1); 
    } 

    if(!fopen($path, "r")) 
    { 
      throw new FileOpenException("文件无法打开", 2); 
    } 
  } 
  catch(Exception $e)               //捕获异常 
  { 
    echo "file_open函数在运行过程中出现异常"; 
    throw $e;                  //重掷异常 
  } 
} 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head> 
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> 
<title>自定义异常处理类</title> 
</head> 
<body> 
<?php 
class TelException extends Exception{      //定义TelException类,继承Exception类 
  public function errorTel(){         //定义方法返回错误信息 
  $errorMsg = "出错原因:".$this->getMessage()."不是一个合法的电话号码"; 
  $errorMsg .="<br>"; 
  $errorMsg .="错误文件路径:".$this->getFile(); 
  $errorMsg .="<br>"; 
  $errorMsg .="错误代码行号:".$this-> getLine();  
  return $errorMsg; 
  } 
} 
function check_tel($tel){              //自定义函数验证电话号码格式是否正确 
  $checkphone="/^13(\d{9})$/";    //定义验证手机号码的正则表达式 
  $counts=preg_match($checkphone,$tel);      //执行验证操作 
  return $counts;                 //返回验证结果 
} 
$tel = "133891gfj";               //定义被验证的电话号码 
/* 
  通过自定义异常处理类返回错误提示 
*/ 
try { 
  if(check_tel($tel) !=1){ 
    throw new TelException($tel); 
  } 
}catch (TelException $e){ 
  include_once("error.php"); 
} 
?> 
</body> 
</html> 
</body> 
</html> 

可怜使用的举世瞩目事项 :

梦想本文所述对我们的php程序设计有着帮助。

二、运行结果

透过上边的案例,大家得以看出,使用

您只怕感兴趣的篇章:

  • PHP的非常管理类Exception的施用及注脚
  • PHP怎么着抛出特别管理错误
  • PHP中的错误管理、分外处理机制剖判
  • php中国和南美洲常管理格局小结
  • PHP中特别管理的一对艺术整理
  • PHP 的可怜管理、错误的抛出及回调函数等面向对象的错误管理方法
  • 二个来得效果特别不利的PHP错误、万分管理类
  • 实例疏解如何在PHP的Yii框架中张开不当和非常管理
  • PHP相当管理Exception类
  • php5编制程序中的非凡管理详细措施介绍
  • php PDO至极管理详解
  • PHP至极处理定义与应用方式剖析

图片 1

try{
    //代码
}catch(Exception $e){
    //对异常处理
}

如上正是本文的全部内容,希望对大家的学习抱有辅助,也可望大家多多支持脚本之家。

这种方式,能够更有效的支配错误.所以在开采中山大学量的使用.

本文由68399皇家赌场发布于呼叫中心培训课程,转载请注明出处:PHP异常处理定义与使用方法分析,php封装一个异

关键词: 68399皇家赌场

最火资讯